Index: src/mlx/checks.py
===================================================================
--- src/mlx/checks.py	(revision 329)
+++ src/mlx/checks.py	(revision 332)
@@ -37,5 +37,5 @@
         This default implementation raises a NotImplementedError."""
         raise NotImplementedError()
-    
+
 #---------------------------------------------------------------------------------------
 
@@ -83,5 +83,5 @@
                 aircraft.setStage(state, const.STAGE_CRUISE)
         elif stage==const.STAGE_LANDING:
-            if state.onTheGround and state.groundSpeed<50.0:
+            if state.onTheGround and state.groundSpeed<25.0:
                 aircraft.setStage(state, const.STAGE_TAXIAFTERLAND)
             elif not state.gearsDown:
@@ -110,5 +110,5 @@
     ## The interval at which the ACARS are sent
     INTERVAL = 3*60.0
-    
+
     def __init__(self, gui):
         """Construct the ACARS sender."""
@@ -119,8 +119,8 @@
         """If the time has come to send the ACARS, send it."""
         now = time.time()
-        
+
         if self._lastSent is not None and \
            (self._lastSent + ACARSSender.INTERVAL)>now:
-            return 
+            return
 
         acars = ACARS(self._gui, state)
@@ -135,5 +135,5 @@
         else:
             print "Failed to send the ACARS"
-        
+
 #---------------------------------------------------------------------------------------
 
@@ -143,5 +143,5 @@
         """Construct the logger."""
         self._onTheGround = True
-    
+
     def check(self, flight, aircraft, logger, oldState, state):
         """Log the cruise speed if necessary."""
@@ -156,5 +156,5 @@
             logger.message(state.timestamp,
                            "Takeoff pitch: %.1f degrees" % (state.pitch,))
-            logger.message(state.timestamp, 
+            logger.message(state.timestamp,
                            "Centre of gravity:  %.1f%%" % (state.cog*100.0,))
             self._onTheGround = False
@@ -167,5 +167,5 @@
         """Construct the logger."""
         self._lastTime = None
-    
+
     def check(self, flight, aircraft, logger, oldState, state):
         """Log the cruise speed if necessary."""
@@ -191,5 +191,5 @@
         self._logged = False
         self._spoilersExtension = None
-    
+
     def check(self, flight, aircraft, logger, oldState, state):
         """Log the cruise speed if necessary."""
@@ -238,5 +238,5 @@
     It tracks the altitude during the descent and landing phases and
     if the altitude crosses one that has a callout associated with and
-    the vertical speed is negative, that callout will be played."""    
+    the vertical speed is negative, that callout will be played."""
     def __init__(self, approachCallouts):
         """Construct the approach callouts player."""
@@ -273,5 +273,5 @@
         the message to log with the new value
         """
-        self._logInitial = logInitial    
+        self._logInitial = logInitial
 
     def _getLogTimestamp(self, state, forced):
@@ -286,5 +286,5 @@
         else:
             shouldLog = self._changed(oldState, state)
-        
+
         if shouldLog:
             self.logState(flight, logger, state)
@@ -295,5 +295,5 @@
         if message is not None:
             logger.message(self._getLogTimestamp(state, forced), message)
-        
+
 #-------------------------------------------------------------------------------
 
@@ -321,5 +321,5 @@
         """Get the value of the attribute from the state."""
         return getattr(state, self._attrName)
-    
+
 #---------------------------------------------------------------------------------------
 
@@ -337,10 +337,10 @@
         self._firstChange = None
         self._lastChangeState = None
-        
+
     def _changed(self, oldState, state):
         """Determine if the value has changed."""
         if self._oldValue is None:
             self._oldValue = self._getValue(oldState)
-            
+
         newValue = self._getValue(state)
         if self._isDifferent(self._oldValue, newValue):
@@ -356,5 +356,5 @@
                 self._firstChange = None
                 return True
-            
+
         return False
 
@@ -384,5 +384,5 @@
     def _getMessage(self, flight, state, forced):
         """Get the message."""
-        value = self._getValue(state)        
+        value = self._getValue(state)
         return None if value is None else self._template % (value,)
 
@@ -433,5 +433,5 @@
         self._logState(flight, logger, state, forced)
         self._lastLoggedState = state
-    
+
     def _changed(self, oldState, state):
         """Check if the state has changed.
@@ -476,5 +476,5 @@
         if obs is not None: message += u" (%d\u00b0)" % (obs,)
         return message
-    
+
     def __init__(self, attrName, logName):
         """Construct the NAV logger."""
@@ -593,5 +593,5 @@
         StateChangeLogger.__init__(self)
         SingleValueMixin.__init__(self, attrName)
-        
+
         self._template = template
 
@@ -599,5 +599,5 @@
         """Get the message from the given state."""
         return self._template % ("ON" if self._getValue(state) else "OFF")
-        
+
 #---------------------------------------------------------------------------------------
 
@@ -741,5 +741,5 @@
         else:
             self._faultStarted = None
-                
+
 #---------------------------------------------------------------------------------------
 
@@ -775,9 +775,9 @@
     """Check for the anti-collision light for Tuplev planes."""
     def isCondition(self, flight, aircraft, oldState, state):
-        """Check if the fault condition holds."""        
+        """Check if the fault condition holds."""
         numEnginesRunning = 0
         for n1 in state.n1:
             if n1>5: numEnginesRunning += 1
-            
+
         if flight.stage==const.STAGE_PARKING:
             return numEnginesRunning<len(state.n1) \
@@ -816,5 +816,5 @@
         """Construct the flaps checker."""
         self._timeStart = None
-    
+
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds.
@@ -891,5 +891,5 @@
         return state.gLoad>2.0 and (flight.stage!=const.STAGE_LANDING or \
                                     state.radioAltitude>=50)
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -923,5 +923,5 @@
                 (flight.stage==const.STAGE_PARKING and \
                  state.landingLightsOn and state.onTheGround))
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -930,5 +930,5 @@
         flight.handleFault(LandingLightsChecker, state.timestamp,
                            FaultChecker._appendDuring(flight, message),
-                           score)   
+                           score)
 
 #---------------------------------------------------------------------------------------
@@ -1018,5 +1018,5 @@
                flight.stage!=const.STAGE_PARKING and \
                not state.navLightsOn
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -1037,10 +1037,10 @@
         """Check if the fault condition holds."""
         return state.overspeed
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
         flight.handleFault(OverspeedChecker, state.timestamp,
                            FaultChecker._appendDuring(flight, "Overspeed"),
-                           20)        
+                           20)
 
 #---------------------------------------------------------------------------------------
@@ -1054,6 +1054,6 @@
         """Check if the given aircraft's ZFW is outside of the limits."""
         return aircraftZFW < (flightZFW - PayloadChecker.TOLERANCE) or \
-               aircraftZFW > (flightZFW + PayloadChecker.TOLERANCE)        
-    
+               aircraftZFW > (flightZFW + PayloadChecker.TOLERANCE)
+
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds."""
@@ -1061,5 +1061,5 @@
                flight.stage==const.STAGE_PUSHANDTAXI and \
                PayloadChecker.isZFWFaulty(state.zfw, flight.zfw)
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -1080,5 +1080,5 @@
         """Check if the fault condition holds."""
         return state.groundSpeed>80 and not state.pitotHeatOn
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -1088,5 +1088,5 @@
         flight.handleFault(PitotChecker, state.timestamp,
                            FaultChecker._appendDuring(flight, "Pitot heat was off"),
-                           score)   
+                           score)
 
 #---------------------------------------------------------------------------------------
@@ -1099,5 +1099,5 @@
                                 const.STAGE_TAXIAFTERLAND] and \
             state.groundSpeed<60 and max(state.reverser)
-                           
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -1117,5 +1117,5 @@
                                 const.STAGE_TAXIAFTERLAND] and \
             state.groundSpeed>50
-                           
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -1136,5 +1136,5 @@
                                 const.STAGE_CRUISE, const.STAGE_DESCENT,
                                 const.STAGE_LANDING] and state.stalled
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -1143,5 +1143,5 @@
         flight.handleFault(StallChecker, state.timestamp,
                            FaultChecker._appendDuring(flight, "Stalled"),
-                           score)   
+                           score)
 
 #---------------------------------------------------------------------------------------
@@ -1160,5 +1160,5 @@
                   (flight.stage==const.STAGE_PARKING and \
                    state.strobeLightsOn and state.onTheGround)
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -1178,5 +1178,5 @@
         return flight.stage==const.STAGE_TAKEOFF and \
                state.n1 is not None and max(state.n1)>97
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
@@ -1209,5 +1209,5 @@
                (altitude<10000 and vs < (VSChecker.BELOW10000 *
                                          VSChecker.TOLERANCE))
-               
+
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""