Index: src/mlx/acft.py
===================================================================
--- src/mlx/acft.py	(revision 338)
+++ src/mlx/acft.py	(revision 340)
@@ -345,5 +345,5 @@
                             "Touchdown heading: %03.0f degrees" % (heading,))
         self.logger.message(self._aircraftState.timestamp,
-                           "Centre of gravity:  %.1f%%" % \
+                           "CG: %.1f%%" % \
                             (self._aircraftState.cog*100.0,))
 
Index: src/mlx/checks.py
===================================================================
--- src/mlx/checks.py	(revision 338)
+++ src/mlx/checks.py	(revision 340)
@@ -157,5 +157,6 @@
                            "Takeoff pitch: %.1f degrees" % (state.pitch,))
             logger.message(state.timestamp,
-                           "Centre of gravity:  %.1f%%" % (state.cog*100.0,))
+                           "CG/Trim: %.1f%%/%.2f" % \
+                           (state.cog*100.0, state.elevatorTrim))
             self._onTheGround = False
 
Index: src/mlx/fs.py
===================================================================
--- src/mlx/fs.py	(revision 337)
+++ src/mlx/fs.py	(revision 340)
@@ -258,4 +258,5 @@
     - apAltitude: the autopilot altitude value in feet (float),
       or None, if the state cannot be read properly
+    - elevatorTrim: a float value indicating the deflection of the elevator
+      trim in degrees
     """
-
Index: src/mlx/fsuipc.py
===================================================================
--- src/mlx/fsuipc.py	(revision 339)
+++ src/mlx/fsuipc.py	(revision 340)
@@ -11,4 +11,5 @@
 import sys
 import codecs
+import math
 
 if os.name == "nt" and "FORCE_PYUIPC_SIM" not in os.environ:
@@ -1194,5 +1195,6 @@
                       ("apHeading", 0x07cc, "H"),
                       ("apAltitudeHold", 0x07d0, "d"),
-                      ("apAltitude", 0x07d4, "u")]
+                      ("apAltitude", 0x07d4, "u"),
+                      ("elevatorTrim", 0x2ea0, "f")]
 
     specialModels = []
@@ -1399,4 +1401,7 @@
         state.apAltitude = data[self._monidx_apAltitude] / \
                            const.FEETTOMETRES / 65536.0
+
+
+        state.elevatorTrim = data[self._monidx_elevatorTrim] * 180.0 / math.pi
 
         return state
Index: src/mlx/gui/monitor.py
===================================================================
--- src/mlx/gui/monitor.py	(revision 337)
+++ src/mlx/gui/monitor.py	(revision 340)
@@ -188,6 +188,7 @@
         table.attach(self._position, 7, 10, 6, 7)
 
-        self._xpdrC = gtk.Label("XPDR CHARLIE")
-        table.attach(self._xpdrC, 10, 12, 6, 7)
+        (label, self._elevatorTrim) = self._createLabeledEntry("Trim:", 5)
+        table.attach(label, 10, 11, 6, 7)
+        table.attach(self._elevatorTrim, 11, 12, 6, 7)
 
         self._apMaster = gtk.Label("AP MASTER")
@@ -207,4 +208,7 @@
         table.attach(label, 6, 7, 7, 8)
         table.attach(self._apAltitude, 7, 8, 7, 8)
+
+        self._xpdrC = gtk.Label("XPDR CHARLIE")
+        table.attach(self._xpdrC, 10, 12, 7, 8)
 
         alignment.add(table)
@@ -282,5 +286,5 @@
             self._windDirection.set_text("-")
             self._position.set_text("-")
-            self._xpdrC.set_sensitive(False)
+            self._elevatorTrim.set_text("-")
             self._apMaster.set_sensitive(False)
             self._apHeadingHold.set_sensitive(False)
@@ -288,4 +292,5 @@
             self._apAltitudeHold.set_sensitive(False)
             self._apAltitude.set_text("-")
+            self._xpdrC.set_sensitive(False)
         else:
             self._timestamp.set_text(time.strftime("%H:%M:%S",
@@ -366,6 +371,5 @@
             self._position.set_text(util.getCoordinateString((aircraftState.latitude,
                                                               aircraftState.longitude)))
-            self._xpdrC.set_sensitive(aircraftState.xpdrC)
-
+            self._elevatorTrim.set_text("%.2f" % (aircraftState.elevatorTrim,))
             self._apMaster.set_sensitive(aircraftState.apMaster)
             self._apHeadingHold.set_sensitive(aircraftState.apHeadingHold)
@@ -374,3 +378,5 @@
             self._apAltitude.set_text("%5.0f" % (aircraftState.apAltitude,))
 
+            self._xpdrC.set_sensitive(aircraftState.xpdrC)
+
 #------------------------------------------------------------------------------